__author__ = 'Kevin Corrigan'

import subprocess
import os


class MazeGenerator:

    Width = -1
    Height = -1
    Seed = -1
    EdgeSpawn = True
    MinimumPathLengthTillEnd = 150
    Tiles = []

    def __init__(self, width, height, seed, edge_spawn=True, minimum_path_length_till_end=159):

        self.Width = width
        self.Height = height
        self.Seed = seed
        self.EdgeSpawn = edge_spawn
        self.MinimumPathLengthTillEnd = minimum_path_length_till_end

    def GenerateMaze(self):

        cur_dir = os.path.dirname(os.path.abspath(__file__))
        file_dir = "%s\\MazeGeneration\\Mazes\\" % cur_dir
        file_path = "%s%s.txt" % (file_dir, self.Seed)

        if os.path.isfile(file_path):
            self.GenerateMazeFromTxt(file_path)
        #else:
        #    self.GenerateMazeImage(cur_dir, file_dir)
        #    self.GenerateMazeFromTxt(file_path)

    def GenerateMazeImage(self, dir_path, file_dir):

        parameters = "%s %s %s %s %s %s" % \
                     (self.Width, self.Height, self.Seed, self.EdgeSpawn, self.MinimumPathLengthTillEnd, file_dir)
        map_generator_dir = "%s\\MazeGeneration\\MazeGenerator.exe" % dir_path
        subprocess.call("%s %s" % (map_generator_dir, parameters))

    def GenerateMazeFromTxt(self, dir_path):

        file = open(dir_path).read()

        for i in range(len(file)):
            self.Tiles.append(file[i])

    def GetCurrentRow(self, index):
        return int(index / self.Height)

    def GetCurrentColumn(self, index):
        return index % self.Width

    def TransformLeft(self, index):

        row = self.GetCurrentRow(index)
        if int((index - 1) / self.Height) == row:
            return index-1
        return index

    def TransformRight(self, index):

        row = self.GetCurrentRow(index)
        if int((index + 1) / self.Height) == row:
            return index+1
        return index

    def TransformUp(self, index):

        new_position = index - self.Width
        if new_position < 0:
            return index
        return new_position

    def TransformDown(self, index):

        new_position = index + self.Width
        if new_position >= self.Width * self.Height:
            return index
        return new_position









