import Settings
from bge import logic
from bge import events
from mathutils import Vector

__author__ = 'Kevin Corrigan'


def Update(cont):

    player = cont.owner
    if not "Stats" in player:
        player["Stats"] = PlayerStats()
    player_stats = player["Stats"]

    movement = Vector([0, 0, 0])
    walking = False
    for key, status in player.sensors["Keyboard"].events:
        if status == logic.KX_INPUT_ACTIVE:
            if key == events.WKEY:
                walking = True
                movement[1] += player_stats.WalkSpeed
            if key == events.SKEY:
                movement[1] -= player_stats.WalkSpeed
            if key == events.DKEY:
                movement[0] += player_stats.WalkSpeed
            if key == events.AKEY:
                movement[0] -= player_stats.WalkSpeed
            if key == events.SPACEKEY:
                movement[2] += player_stats.WalkSpeed * 25
            if key == events.LEFTSHIFTKEY and walking:
                if movement[1] > 0:
                    movement[1] = 0
                movement[1] += player_stats.RunningSpeed

    if movement != Vector([0, 0, 0]):
        movement = player.worldOrientation * movement

    player.worldPosition += movement

class PlayerStats:

    def __init__(self):

        self.MaxHealth = Settings.Player_MaxHealth
        self.WalkSpeed = Settings.Player_WalkingSpeed
        self.RunningSpeed = Settings.Player_RunningSpeed
