import Settings
import random
from mathutils import Vector
from math import radians
from bge import render

__author__ = 'Kevin'


def Update(cont):

    tourist = cont.owner

    if not "Stats" in tourist:
        tourist["Stats"] = TouristStats()

    tourist_stats = tourist["Stats"]

    if tourist_stats.FrameCount == 0:
        left_side = tourist.worldOrientation * Vector([-1.5, 0, 0])
        right_side = tourist.worldOrientation * Vector([1.5, 0, 0])
        front = tourist.worldOrientation * Vector([0, 1.5, 0])

        left_side += tourist.worldPosition
        right_side += tourist.worldPosition
        front += tourist.worldPosition

        render.drawLine(tourist.worldPosition, left_side, [1, 0, 0])
        render.drawLine(tourist.worldPosition, right_side, [1, 0, 0])
        render.drawLine(tourist.worldPosition, front, [1, 0, 0])

        front_ray = tourist.rayCast(front, tourist, 0.5)
        left_ray = tourist.rayCast(left_side, tourist, 2)
        right_ray = tourist.rayCast(right_side,tourist, 2)

        rotation = Vector([0, 0, 0])
        if front_ray[0]:
            if not left_ray[0] and not right_ray[0]:
                go_left = bool(random.randint(0, 2))

                if go_left:
                    rotation[2] = radians(-90)
                else:
                    rotation[2] = radians(90)
            elif left_ray[0] and right_ray[0]:
                rotation[2] = radians(-180)
            elif not left_ray[0]:
                rotation[2] = radians(90)
            else:
                rotation[2] = radians(-90)
        elif not left_ray[0] and bool(random.randint(0, 2)):
            rotation[2] = radians(90)
        elif not right_ray[0]:
            rotation[2] = radians(-90)
        if rotation != Vector([0, 0, 0]):
            tourist.applyRotation(rotation)

    tourist.worldPosition += tourist.worldOrientation * Vector([0, tourist_stats.WalkingSpeed, 0])
    tourist_stats.FrameCount += 1
    if tourist_stats.FrameCount >= 99:
        tourist_stats.FrameCount = 0


class TouristStats:

    def __init__(self):

        self.WalkingSpeed = Settings.Tourist_WalkingSpeed
        self.FrameCount = 0